#!/bin/sh
echo ""
echo "mkiso start"
ISOLX_DIR="/_config/backup/isolinux"
INST_DIR="/_config/backup"
if [ "$1" = "" ] ; then
   TARGET="/mnt/data/vdr.iso"
else
   TARGET=$1
fi   
for i in /mnt/data/g2v_*.tar.lzma ; do  
   echo "Checking $i ..."
#   tar -tjvf $i > /tmp/g2v.log 2>&1 
   if [ "$?" != "0" ] ; then
      cat /tmp/g2v.log
      exit
   fi   
done

rm -v $TARGET
mkisofs -o $TARGET -allow-leading-dots -graft-points -l -J -r -p ACTIVY -publisher ACTIVY -V ACTIVY \
        -b isolinux/isolinux.bin -c isolinux/boot.cat \
        -no-emul-boot -boot-load-size 4 -boot-info-table \
        /mnt/data/g2v_*.tar.lzma /isolinux/=$ISOLX_DIR/ $INST_DIR/setup.sh \
	$INST_DIR/autorun $ISOLX_DIR/README $ISOLX_DIR/HISTORY /doc/=/usr/local/share/doc/vdr/
	
echo "mkiso end"
echo ""
